/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Contents of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.32 - (show annotations) (download)
Sun Sep 10 10:29:21 2006 UTC (8 years, 3 months ago) by zzam
Branch: MAIN
Changes since 1.31: +12 -1 lines
Modified vdr-plugin_copy_source_tree to stay in the same directory. Added code to detect a missing call to vdr-plugin_src_unpack.

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.31 2006/09/07 18:49:44 zzam Exp $
4 #
5 # Author:
6 # Matthias Schwarzott <zzam@gentoo.org>
7 # Joerg Bornkessel <hd_brummy@gentoo.org>
8
9 # vdr-plugin.eclass
10 #
11 # eclass to create ebuilds for vdr plugins
12 #
13
14 # Example ebuild (vdr-femon):
15 #
16 # inherit vdr-plugin
17 # IUSE=""
18 # SLOT="0"
19 # DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20 # HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21 # SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22 # LICENSE="GPL-2"
23 # KEYWORDS="~x86"
24 # DEPEND=">=media-video/vdr-1.3.27"
25 #
26 #
27
28 # Installation of a config file for the plugin
29 #
30 # If ${VDR_CONFD_FILE} is set install this file
31 # else install ${FILESDIR}/confd if it exists.
32
33 # Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34 # For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37 # Installation of an rc-addon file for the plugin
38 #
39 # If ${VDR_RCADDON_FILE} is set install this file
40 # else install ${FILESDIR}/rc-addon.sh if it exists.
41 #
42 # Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43 # (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh)
44 #
45 # This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46 # It could be used for special startup actions for this plugins, or to create the
47 # plugin command line options from a nicer version of a conf.d file.
48
49 # HowTo use own local patches; Example
50 #
51 # Add to your /etc/make.conf:
52 # VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53 #
54 # Add two DIR's in your local patch dir, ${PN}/${PV},
55 # e.g for vdr-burn-0.1.0 should be:
56 # /usr/local/patch/vdr-burn/0.1.0/
57 #
58 # all patches which ending on diff or patch in this DIR will automatically applied
59 #
60
61 inherit base multilib eutils flag-o-matic
62
63 IUSE="debug"
64
65 # Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66 VDRPLUGIN="${PN/#vdrplugin-/}"
67 VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68 VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
69
70 DESCRIPTION="vdr Plugin: ${VDRPLUGIN} (based on vdr-plugin.eclass)"
71
72 # works in most cases
73 S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74
75 # depend on headers for DVB-driver
76 RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1"
77 DEPEND="media-tv/linuxtv-dvb-headers"
78
79
80 # this code is from linux-mod.eclass
81 update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92 }
93
94 remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101 }
102
103 vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC
106 use debug && append-flags -g
107
108 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111
112 # transition to /usr/share/... will need new vdr-scripts version stable
113 VDR_RC_DIR="/usr/lib/vdr/rcscript"
114
115 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include"
118
119
120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
123
124 einfo "Building ${PF} against vdr-${VDRVERSION}"
125 einfo "APIVERSION: ${APIVERSION}"
126 }
127
128 vdr-plugin_src_unpack() {
129 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
130 eerror "Wrong use of vdr-plugin.eclass."
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo
133 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!"
135 fi
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
137
138 while [ "$1" ]; do
139
140 case "$1" in
141 unpack)
142 base_src_unpack
143 ;;
144 patchmakefile)
145 if ! cd ${S}; then
146 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
147 ewarn "Perhaps you find one among these:"
148 cd "${WORKDIR}"
149 einfo "$(/bin/ls -1 ${WORKDIR})"
150 die "Could not change to plugin-source-directory!"
151 fi
152
153 einfo "Patching Makefile"
154 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
155 cp Makefile Makefile.orig
156
157 sed -i Makefile \
158 -e '1i\#Makefile was patched by vdr-plugin.eclass'
159
160 ebegin " Setting Pathes"
161 sed -i Makefile \
162 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
163 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
164 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
165 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
166 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
167 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
168 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
169 eend $?
170
171 ebegin " Converting to APIVERSION"
172 sed -i Makefile \
173 -e 's:^APIVERSION = :APIVERSION ?= :' \
174 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
175 -e '2i\APIVERSION = '"${APIVERSION}"
176 eend $?
177
178 ebegin " Correcting CXXFLAGS"
179 sed -i Makefile \
180 -e 's:^CXXFLAGS:#CXXFLAGS:'
181 eend $?
182
183 ebegin " Disabling file stripping"
184 sed -i Makefile \
185 -e '/@.*strip/d' \
186 -e '/strip \$(LIBDIR)\/\$@/d' \
187 -e '/^STRIP =/d' \
188 -e '/@.*\$(STRIP)/d'
189 eend $?
190 PLUGIN_MAKEFILE_PATCHED=1
191 ;;
192 add_local_patch)
193 cd ${S}
194 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
195 echo
196 einfo "Applying local patches"
197 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
198 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
199 done
200 fi
201 ;;
202 esac
203
204 shift
205 done
206 }
207
208 vdr-plugin_copy_source_tree() {
209 pushd . >/dev/null
210 cp -r ${S} ${T}/source-tree
211 cd ${T}/source-tree
212 mv Makefile.orig Makefile
213 sed -i Makefile \
214 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
215 -e 's:^CXXFLAGS:#CXXFLAGS:' \
216 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
217 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
218 popd >/dev/null
219 }
220
221 vdr-plugin_install_source_tree() {
222 einfo "Installing sources"
223 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
224 insinto ${destdir}-${PV}
225 doins -r ${T}/source-tree/*
226
227 dosym ${VDRPLUGIN}-${PV} ${destdir}
228 }
229
230 vdr-plugin_src_compile() {
231 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
232
233 while [ "$1" ]; do
234
235 case "$1" in
236 prepare)
237 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
238 ;;
239 compile)
240 if [[ -z ${PLUGIN_MAKEFILE_PATCHED} ]]; then
241 eerror "Wrong use of vdr-plugin.eclass."
242 eerror "An ebuild for a vdr-plugin will not work without"
243 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
244 echo
245 eerror "Please report this at bugs.gentoo.org."
246 die "vdr-plugin_src_unpack not called!"
247 fi
248 cd ${S}
249
250 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
251 ;;
252 esac
253
254 shift
255 done
256 }
257
258 vdr-plugin_src_install() {
259 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
260 cd ${S}
261
262 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
263 local mname=${P}-Makefile
264 cp Makefile ${mname}.patched
265 cp Makefile.orig ${mname}.before
266
267 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
268
269 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
270 doins ${mname}.diff
271
272 insinto "/usr/share/vdr/maintainer-data/makefile-before"
273 doins ${mname}.before
274
275 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
276 doins ${mname}.patched
277
278 fi
279
280 insinto "${VDR_PLUGIN_DIR}"
281 doins libvdr-*.so.*
282 local docfile
283 for docfile in README* HISTORY CHANGELOG; do
284 [[ -f ${docfile} ]] && dodoc ${docfile}
285 done
286
287 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
288 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
289
290 if [[ -n ${VDR_CONFD_FILE} ]]; then
291 insinto /etc/conf.d
292 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
293 fi
294
295
296 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
297 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
298
299 if [[ -n ${VDR_RCADDON_FILE} ]]; then
300 insinto "${VDR_RC_DIR}"
301 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
302 fi
303
304
305
306 insinto ${VDR_CHECKSUM_DIR}
307 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
308 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
309 else
310 if which md5sum >/dev/null 2>&1; then
311 cd ${S}
312 (
313 cd ${ROOT}${VDR_INCLUDE_DIR}
314 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
315 ) > header-md5-${PN}
316 doins header-md5-${PN}
317 fi
318 fi
319 }
320
321 vdr-plugin_pkg_postinst() {
322 update_vdrplugindb
323 einfo
324 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
325 einfo "To activate execute the following command:"
326 einfo
327 einfo " emerge --config ${PN}"
328 einfo
329 if [[ -n "${VDR_CONFD_FILE}" ]]; then
330 einfo "And have a look at the config-file"
331 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
332 einfo
333 fi
334 }
335
336 vdr-plugin_pkg_postrm() {
337 remove_vdrplugindb
338 }
339
340 vdr-plugin_pkg_config_final() {
341 diff ${conf_orig} ${conf}
342 rm ${conf_orig}
343 }
344
345 vdr-plugin_pkg_config() {
346 if [[ -z "${INSTALLPLUGIN}" ]]; then
347 INSTALLPLUGIN="${VDRPLUGIN}"
348 fi
349 # First test if plugin is already inside PLUGINS
350 local conf=/etc/conf.d/vdr
351 conf_orig=${conf}.before_emerge_config
352 cp ${conf} ${conf_orig}
353
354 einfo "Reading ${conf}"
355 if ! grep -q "^PLUGINS=" ${conf}; then
356 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
357 if [[ -n "${LINE}" ]]; then
358 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
359 else
360 echo 'PLUGINS=""' >> ${conf}
361 fi
362 unset LINE
363 fi
364
365 unset PLUGINS
366 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
367
368 active=0
369 for p in ${PLUGINS}; do
370 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
371 active=1
372 break;
373 fi
374 done
375
376 if [[ "${active}" == "1" ]]; then
377 einfo "${INSTALLPLUGIN} already activated"
378 echo
379 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
380 if [[ "${answer}" != "yes" ]]; then
381 einfo "aborted"
382 return
383 fi
384 einfo "Removing ${INSTALLPLUGIN} from active plugins."
385 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
386 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
387 -e ${LINE}'s/ \( \)*/ /g' \
388 -e ${LINE}'s/ "/"/g' \
389 -e ${LINE}'s/" /"/g'
390
391 vdr-plugin_pkg_config_final
392 return
393 fi
394
395
396 einfo "Adding ${INSTALLPLUGIN} to active plugins."
397 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
398 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
399 -e ${LINE}'s/ \( \)*/ /g' \
400 -e ${LINE}'s/ "/"/g' \
401 -e ${LINE}'s/" /"/g'
402
403 vdr-plugin_pkg_config_final
404 }
405
406 fix_vdr_libsi_include()
407 {
408 einfo "Fixing include of libsi-headers"
409 local f
410 for f; do
411 sed -i "${f}" \
412 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
413 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
414 done
415 }
416
417 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

  ViewVC Help
Powered by ViewVC 1.1.20